config/routes.rb
Rails.application.routes.draw do
  root 'static_pages#home'
  get    'stats'            => 'static_pages#stats'
  get    'about'           => 'static_pages#about'
  get    'contact'         => 'static_pages#contact'
  get    'login'           => 'sessions#new'
  post   'login'           => 'sessions#create'
  delete 'logout'          => 'sessions#destroy'
  resources :schools, :except => [:index]
  get       'schools'          => 'schools#show', :defaults => { :id => "1" }
  resources :students
  get       'students_signup'  => 'students#new'
  get       'students_load_suggestions' => 'students#load_suggestions'
  get       'students_redirect' => 'students#redirect'
  resources :companies
  get       'companies_signup' => 'companies#new'
  resources :skills
  resources :account_activations, only: [:edit]
  resources :password_resets,     only: [:new, :create, :edit, :update]
  resources :matches
  resources :stages

end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController
  def home
    companies   = Company.all.eager_load(:company_skills)
    students    = Student.all.eager_load(:student_skills)
    s_averages    = []
    students.each{|s| s_averages.push(s.student_skills.map{|ss| ss.level}.
                                      inject(:+)/s.student_skills.length.to_f)}
    avgsskills   = s_averages.inject(:+) / s_averages.length

    c_averages    = []
    companies.each{|c| c_averages.push(c.company_skills.map{|cs| cs.level}.
                                      inject(:+)/c.company_skills.length.to_f)}
    avgcskills   = c_averages.inject(:+) / c_averages.length

    @stats = { ncompanies: companies.length,
               nstudents:  students.length,
               nskills:    Skill.all.length,
               nstages:    Stage.all.length,
               avgsskills: avgsskills.round(2),
               avgcskills: avgcskills.round(2)
             }
  end

  def stats
    companies   = Company.all.eager_load(:company_skills)
    students    = Student.all.eager_load(:student_skills)
    s_averages    = []
    students.each{|s| s_averages.push(s.student_skills.map{|ss| ss.level}.
                                      inject(:+)/s.student_skills.length.to_f)}
    avgsskills   = s_averages.inject(:+) / s_averages.length

    c_averages    = []
    companies.each{|c| c_averages.push(c.company_skills.map{|cs| cs.level}.
                                      inject(:+)/c.company_skills.length.to_f)}
    avgcskills   = c_averages.inject(:+) / c_averages.length

    @stats = { ncompanies: companies.length,
               nstudents:  students.length,
               nskills:    Skill.all.length,
               nstages:    Stage.all.length,
               avgsskills: avgsskills.round(2),
               avgcskills: avgcskills.round(2)
             }
  end

  def about
  end
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper

  

end

app/views/static_pages/about.html.erb
<% provide(:title, "Su di me") %>
<h1>Su di me</h1>
To do

app/views/static_pages/contact.html.erb
<% provide(:title, 'Contatti') %>
<h1>Contatti</h1>
<p>
To do
</p>
 

app/views/static_pages/home.html.erb
<% provide(:title, "Home") %>
<h1 style="margin-top:30px;"><b>BESTAGE</b></h1>

<div class="row" id="desc">
  Una soluzione alle 400 ore di alternanza scuola-lavoro che può assegnare ad
  ogni studente l'azienda a lui più adatta, in base ad un abbinamento tra le sue
  competenze e quelle richieste dalle aziende, puntando l'attenzione soprattutto
  sul livello con cui esse sono state da lui apprese e sul livello di richiesta
  dell'azienda delle stesse.
</div>
<div class="row" id="signup-container">
  <%= link_to "Sei un'azienda? Registrati!", companies_signup_path, class: "btn btn-primary" %>
</div>

<div class="row v-align">
  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-briefcase" aria-hidden="true"></span>
      </div>
      <div class="number"><%= @stats[:ncompanies] %></div>
      Aziende registrate
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-user"></span>
      </div>
      <div class="number"><%= @stats[:nstudents] %></div>
      Studenti presenti sul sito
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-tasks"></span>
      </div>
      <div class="number"><%= @stats[:nskills] %></div>
      Competenze offerte dalla scuola
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-calendar"></span>
      </div>
      <div class="number"><%= @stats[:nstages] %></div>
      Stage iniziati
    </div>
  </div>
</div>

<div class="row v-align">
  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-stats"></span>
      </div>
      <div class="number"><%= @stats[:avgsskills] %></div>
      Livello medio delle competenze degli studenti<br>
      <small>(scala da 0 a 5)</small>
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-stats"></span>
      </div>
      <div class="number"><%= @stats[:avgcskills] %></div>
      Livello medio delle competenze richieste dalle aziende<br>
      <small>(scala da 0 a 5)</small>
    </div>
  </div>
</div>

app/views/static_pages/stats.html.erb
<% provide(:title, "Statistiche") %>
<h1>Statistiche</h1>
<div class="row v-align">
  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-briefcase" aria-hidden="true"></span>
      </div>
      <div class="number"><%= @stats[:ncompanies] %></div>
      Aziende registrate
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-user"></span>
      </div>
      <div class="number"><%= @stats[:nstudents] %></div>
      Studenti presenti sul sito
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-tasks"></span>
      </div>
      <div class="number"><%= @stats[:nskills] %></div>
      Competenze offerte dalla scuola
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-calendar"></span>
      </div>
      <div class="number"><%= @stats[:nstages] %></div>
      Stage iniziati
    </div>
  </div>
</div>

<div class="row v-align">
  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-stats"></span>
      </div>
      <div class="number"><%= @stats[:avgsskills] %></div>
      Livello medio delle competenze degli studenti<br>
      <small>(scala da 0 a 5)</small>
    </div>
  </div>

  <div class="stat">
    <div>
      <div class="icon">
        <span class="glyphicon glyphicon-stats"></span>
      </div>
      <div class="number"><%= @stats[:avgcskills] %></div>
      Livello medio delle competenze richieste dalle aziende<br>
      <small>(scala da 0 a 5)</small>
    </div>
  </div>
</div>